function Rec11004_RelatorioCustomizavelRateiosTitulosReceberRecebido_Controller(General, ScreenService, templateManager, ZHPromise, ZhFilterPreferences, restEngine) {
    
    var self = this;
    
    self.openFilterTitulosARecebido = function(widgetTitulosAReceber){
        self.buscaDadosIniciaisFiltro(widgetTitulosAReceber).then(function(){
            var rowSetFilter = {
                'DTVENBOLREC' : widgetTitulosAReceber.DTVENBOLREC,
                'CDEMPRESA'   : widgetTitulosAReceber.empresa.CDEMPRESA,
                'NMEMPRESA'   : widgetTitulosAReceber.empresa.NMEMPRESA
            };
            ZhFilterPreferences.setOriginalFilter(widgetTitulosAReceber.id, rowSetFilter);
            ZhFilterPreferences.openFilterWidget(widgetTitulosAReceber, rowSetFilter);
            
        });

    };
    
    self.buscaDadosIniciaisFiltro = function(widgetTitulosAReceber) {
        var deferred = ZHPromise.defer();
        self.buscaPadraoEmpresa(widgetTitulosAReceber).then(function(){
            self.buscaPadraoIntervaloVencimento(widgetTitulosAReceber).then(function(){
                deferred.resolve();
            });    
        });
        
        return deferred.promise;
    };
    
    self.buscaPadraoEmpresa = function(widget) {
        var deferred = ZHPromise.defer();
        var filterFilial = [{"name": "CDFILIAL", "operator": "=", "value": "FILIAL_LOGADA"}];
        var routeFilial = 'fin#/crud/filial';
        General.callRestEngine(routeFilial, 'FilterData', filterFilial).then(function(response_filial){
            var filial   = response_filial.dataset.filial[0];
            var routeEmpresa = 'fin#/crud/empresa_filial_filioper';
            var filterEmpresa = [
                {"name": "CDEMPRESA", "operator": "=", "value": filial.CDEMPRESA},
                {"name": "CDOPERADOR", "operator": "=", "value": getLocalVar('CDOPERADOR')}
            ];
            General.callRestEngine(routeEmpresa, 'FilterData', filterEmpresa).then(function(response_empresa){
                var empresa = response_empresa.dataset.empresa_filial_filioper[0];
                widget.empresa = empresa;
                deferred.resolve();
            });
        });
        
        return deferred.promise;
    };
    
    self.buscaGeralRec = function(){
        return General.callRestEngine(
            'fin#/crud/geral_rec',
            'FilterData',
            []
        );
    };
    
    self.buscaParamEstoque = function(cdFilialOpcional) {
        var filter = [{"name": "CDFILIAL", "operator": "=", "value": 'FILIAL_LOGADA'}];
        return General.callRestEngine(
            'fin#/crud/paramestoque_processamento',
            'FilterData',
            filter
        ); 
    };
    
    self.buscaPadraoIntervaloVencimento = function (widget){
        var deferred = ZHPromise.defer();
        var geralrec     = self.buscaGeralRec();
        var paramestoque = self.buscaParamEstoque();

        ZHPromise.all([geralrec, paramestoque]).then(function(response){
            geralrec     = response[0].dataset.geral_rec[0];
            paramestoque = response[1].dataset.paramestoque_processamento[0];

            var qtdiaantlanr = geralrec?geralrec.QTDIAANTBOLP?geralrec.QTDIAANTBOLP:0:0;
            var qtdiaapolanr = geralrec?geralrec.QTDIAAPOBOLP?geralrec.QTDIAAPOBOLP:0:0;
            var dtprocessa   = paramestoque?paramestoque.DTPROCESSA?paramestoque.DTPROCESSA:moment():moment();

            var start = moment(dtprocessa, 'DD/MM/YYYY').subtract(qtdiaantlanr, 'days').format('DD/MM/YYYY');
            var end   = moment(dtprocessa, 'DD/MM/YYYY').add(qtdiaapolanr, 'days').format('DD/MM/YYYY');

            widget.DTVENBOLREC = {start : start, end : end};
            deferred.resolve();
        });
        return deferred.promise;
    };
    
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Rec11004_RelatorioCustomizavelRateiosTitulosReceberRecebido_Controller', Rec11004_RelatorioCustomizavelRateiosTitulosReceberRecebido_Controller);
});